﻿using CoreLibrary.Joueurs;

namespace CoreLibrary.Manager
{
    public class Manager : IDisposable
    {
        private readonly IPersistanceManager persistance;

        private readonly IEnumerable<Joueur> joueurs;
        public IEnumerable<Joueur> Joueurs => joueurs;

        public Manager(IPersistanceManager persistance)
        {
            this.persistance = persistance;
            joueurs = this.persistance.Charger();
        }

        public void Dispose()
        {
            persistance.Enregistrer(joueurs);

            GC.SuppressFinalize(this);
        }
    }
}
